using System;
using System.Collections.Generic;
using Caliburn.Micro;

namespace Exones.Blend.AssetsManager
{
	class BlendVersionAssets
	{
		private IObservableCollection<BlendFolder> assetFolders;

		public BlendVersion BlendVersion { get; private set; }

		public IObservableCollection<BlendFolder> AssetFolders
		{
			get { return assetFolders; }
		}

		public BlendVersionAssets(BlendVersion blendVersion, IEnumerable<BlendFolder> assetFolders)
		{
			if (blendVersion == null) throw new ArgumentNullException("blendVersion");
			if (assetFolders == null) throw new ArgumentNullException("assetFolders");

			BlendVersion = blendVersion;
			this.assetFolders = new BindableCollection<BlendFolder>(assetFolders);
		}
	}
}